from time import sleep

from pyhamtools.locator import latlong_to_locator

from data.sig_ref import SIGRef
from providers.sigrefdata.file_download_sig_ref_data_provider import FileDownloadSIGRefDataProvider


class ZLOTA(FileDownloadSIGRefDataProvider):
    """SIG ref data provider for New Zealand on the Air"""

    POLL_INTERVAL_DAYS = 30
    SIG = "ZLOTA"
    DATA_URL = "https://ontheair.nz/assets/assets.json"

    def __init__(self, provider_config):
        super().__init__(self.SIG, provider_config, self.DATA_URL, self.POLL_INTERVAL_DAYS)

    def _http_response_to_data(self, http_response):
        new_data = []
        data = http_response.json()
        if isinstance(data, list):
            for ref in data:
                ref_id = ref["code"]
                latitude = ref["latitude"]
                longitude = ref["longitude"]

                new_ref = SIGRef(sig=self.SIG, id=ref_id, name=ref["name"],
                                          ref_type=ref["asset_type"].title,
                                          url="https://ontheair.nz/assets/" + ref_id.replace("/", "_"),
                                          latitude=latitude,
                                          longitude=longitude)

                # Check lat/lon validity and update grid accordingly
                if latitude and longitude:
                    try:
                        new_ref.grid = latlong_to_locator(latitude, longitude, 6)
                    except ValueError:
                        # Junk lat/lon, remove from the spot
                        new_ref.latitude = None
                        new_ref.longitude = None

                new_data.append(new_ref)

                # Bail out if a stop has been requested, i.e. the program is shutting down - no need to parse the rest
                # of the data in this case
                if self._stop_event.is_set():
                    break

                # Very short pause. This will extend the time to handle sig refs by a few seconds but will ensure some time
                # is available for other threads e.g. the web server.
                sleep(0.001)

        return new_data
